#[doc = "Register `MC2` reader"]
pub struct R(crate::R<MC2_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<MC2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<MC2_SPEC>> for R {
    fn from(reader: crate::R<MC2_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `MC2` writer"]
pub struct W(crate::W<MC2_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<MC2_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<MC2_SPEC>> for W {
    fn from(writer: crate::W<MC2_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `PLD0_MC_LS` reader - Read Macrocell 0 for UDB\\[n\\]"]
pub struct PLD0_MC_LS_R(crate::FieldReader<u8, u8>);
impl PLD0_MC_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD0_MC_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC_LS` reader - Read Macrocell 1 for UDB\\[n\\]"]
pub struct PLD1_MC_LS_R(crate::FieldReader<u8, u8>);
impl PLD1_MC_LS_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC_LS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD1_MC_LS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD0_MC_MS` reader - Read Macrocell 0 for UDB\\[n+1\\]"]
pub struct PLD0_MC_MS_R(crate::FieldReader<u8, u8>);
impl PLD0_MC_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD0_MC_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD0_MC_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `PLD1_MC_MS` reader - Read Macrocell 1 for UDB\\[n+1\\]"]
pub struct PLD1_MC_MS_R(crate::FieldReader<u8, u8>);
impl PLD1_MC_MS_R {
    pub(crate) fn new(bits: u8) -> Self {
        PLD1_MC_MS_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for PLD1_MC_MS_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl R {
    #[doc = "Bits 0:3 - Read Macrocell 0 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn pld0_mc_ls(&self) -> PLD0_MC_LS_R {
        PLD0_MC_LS_R::new((self.bits & 0x0f) as u8)
    }
    #[doc = "Bits 4:7 - Read Macrocell 1 for UDB\\[n\\]"]
    #[inline(always)]
    pub fn pld1_mc_ls(&self) -> PLD1_MC_LS_R {
        PLD1_MC_LS_R::new(((self.bits >> 4) & 0x0f) as u8)
    }
    #[doc = "Bits 8:11 - Read Macrocell 0 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn pld0_mc_ms(&self) -> PLD0_MC_MS_R {
        PLD0_MC_MS_R::new(((self.bits >> 8) & 0x0f) as u8)
    }
    #[doc = "Bits 12:15 - Read Macrocell 1 for UDB\\[n+1\\]"]
    #[inline(always)]
    pub fn pld1_mc_ms(&self) -> PLD1_MC_MS_R {
        PLD1_MC_MS_R::new(((self.bits >> 12) & 0x0f) as u8)
    }
}
impl W {
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "PLD Macrocell reading\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [mc2](index.html) module"]
pub struct MC2_SPEC;
impl crate::RegisterSpec for MC2_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [mc2::R](R) reader structure"]
impl crate::Readable for MC2_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [mc2::W](W) writer structure"]
impl crate::Writable for MC2_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets MC2 to value 0"]
impl crate::Resettable for MC2_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
